package dashboard

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/operation/src/dashboard/model"
	"shylinux.com/x/operation/src/operation"
)

type Table struct {
	operation.Table
	list string `name:"list dashboard_uid uid auto" role:"leader,worker,server"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.USER_DASHBOARD_ROLE:
		s.InputsListRole(m, UserDashboardRoleList, arg...)
	case model.DASHBOARD_TYPE:
		s.InputsListSkip(m, DashboardTypeList, kit.Select("0", "-1", m.IsTech()), arg...)
	default:
		s.Table.Inputs(m, arg...)
	}
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		switch key {
		case model.USER_DASHBOARD_ROLE:
			value = UserDashboardRole(kit.Int(value)).String()
		case model.DASHBOARD_TYPE:
			value = DashboardType(kit.Int(value)).String()
		}
		return value
	})
	return s.Table.RewriteAppend(m)
}

type Tables struct{ Table }

func (s Tables) BeforeMigrate(m *ice.Message, arg ...string) {}
